import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrServer {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  Name?: string;
  Address?: string;
  Port!: number;
  Size!: number;
  Status!: number;
  ExpireDate?: Date;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrServerSchema = defineEntity({
  class: IcrServer,
  comment: '服务器',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    Name: p.string().name('Name').nullable().comment('姓名'),
    Address: p.string().name('Address').nullable().comment('地址'),
    Port: p.integer().name('Port').comment('端口'),
    Size: p.integer().name('Size').comment('容量'),
    Status: p.integer().name('Status').comment('状态'),
    ExpireDate: p.datetime().name('ExpireDate').length(3).nullable().comment('过期时间(天)'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
